SystemOrganization addCategory: #'KwisatzHaderach-StackListener'!
SystemOrganization addCategory: #KwisatzHaderach!
SystemOrganization addCategory: #'KwisatzHaderach-Tests'!

Object subclass: #CommonExpressions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-Tests'!

!CommonExpressions class methodsFor: 'arithmetic' stamp: 'SantiagoBragagnolo 6/5/2012 23:14'!
commonAdd
	| a b |
	a:= 1.
	b:=2.
	a := a + b.
	^a ! !

Object subclass: #KwisatzHaderach
	instanceVariableNames: 'result stackListener'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach'!

!KwisatzHaderach class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 6/5/2012 22:41'!
callgraphFor: anExpression
	| instance | 
	instance := self new.
	^instance callgraphFor: anExpression
	! !

!KwisatzHaderach methodsFor: 'callgraph' stamp: 'SantiagoBragagnolo 6/5/2012 23:17'!
callgraphFor: anExpression
	result := Compiler new analyze: anExpression  in:  nil to: nil notifying: nil ifFail:[ :fail | self manage: fail].
	^ self.! !

!KwisatzHaderach methodsFor: 'initialize' stamp: 'SantiagoBragagnolo 6/5/2012 23:20'!
initialize 
	super initialize.
	TiPrimitive initialize.
	TiSystem current reset.
	stackListener := StackListener for: self.
	
	self registerToStackAnnouncements.
	
! !

!KwisatzHaderach methodsFor: 'error' stamp: 'SantiagoBragagnolo 6/5/2012 22:46'!
manage: fail
	self error: fail.! !

!KwisatzHaderach methodsFor: 'initialize' stamp: 'SantiagoBragagnolo 6/5/2012 23:22'!
registerToStackAnnouncements
	TiSystem current interpreter subscribe: StackPoped send:#announcePop: to: self stackListener.
	TiSystem current interpreter subscribe: StackPushed send:#announcePop: to: self stackListener.! !

!KwisatzHaderach methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/5/2012 23:15'!
stackListener 
	^stackListener ! !

!KwisatzHaderach methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/5/2012 23:15'!
stackListener: aListener
	stackListener := aListener.! !

Object subclass: #KwisatzHaderachWorkspace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-Tests'!

!KwisatzHaderachWorkspace methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/5/2012 23:15'!
callgraphCommonAdd
" self new callgraphCommonAdd "
	KwisatzHaderach callgraphFor: 'CommonExpressions commonAdd'.! !

Object subclass: #StackListener
	instanceVariableNames: 'classMap selectorMap methodMap owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-StackListener'!

!StackListener class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/5/2012 23:18'!
for: aKwisatzHaderach 
	| instance | 
	instance := self new.
	instance owner: aKwisatzHaderach.
	^instance. ! !

!StackListener methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 6/5/2012 22:38'!
announcePop: aStackPoped 
	self halt.! !

!StackListener methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 6/5/2012 23:52'!
announcePush: aStackPushed
| anObjectType argumentsArray messageId senderMessageId |
	
	anObjectType := aStackPushed receptor veryDeepCopyWithContext: ContextualDeepCopier kwisatzHaderach.
	argumentsArray := aStackPushed arguments.
	
	! !

!StackListener methodsFor: 'map access' stamp: 'SantiagoBragagnolo 6/5/2012 22:11'!
classRepresentation: aClass
	^classMap at: aClass  ifAbsentPut: [
		self makeAClassRepresentation: aClass.
	].
! !

!StackListener methodsFor: 'initialize' stamp: 'SantiagoBragagnolo 6/5/2012 22:23'!
initialize
	classMap := Dictionary new.
	selectorMap := Dictionary new.
	methodMap := Dictionary new.! !

!StackListener methodsFor: 'private' stamp: 'SantiagoBragagnolo 6/5/2012 22:11'!
makeAClassRepresentation: aClass
	^ MAContainer new.! !

!StackListener methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/5/2012 23:19'!
owner
 	^owner! !

!StackListener methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/5/2012 23:19'!
owner: aKwisatzHaderach 	
 	owner := aKwisatzHaderach.! !
